#include "rtc.h"
#include "delay.h"
#include "usart.h" 

//ȴRSFͬ
//ֵ:0,ɹ;1,ʧ;
u8 RTC_Wait_Synchro(void)
{ 
	u32 retry=0XFFFFF; 
	//رRTCĴд
	RTC->WPR=0xCA;
	RTC->WPR=0x53; 
	RTC->ISR&=~(1<<5);		//RSFλ 
	while(retry&&((RTC->ISR&(1<<5))==0x00))//ȴӰӼĴͬ
	{
		retry--;
	}
    if(retry==0)return 1;	//ͬʧ 
	RTC->WPR=0xFF;			//ʹRTCĴд  
	return 0;
}
//RTCʼģʽ
//ֵ:0,ɹ;1,ʧ;
u8 RTC_Init_Mode(void)
{ 
	u32 retry=0X10000; 
	if(RTC->ISR&(1<<6))return 0; 
	RTC->ISR|=1<<7;	//RTCʼģʽ
	while(retry&&((RTC->ISR&(1<<6))==0x00))//ȴRTCʼģʽɹ
	{
		retry--;
	}
    if(retry==0)return 1;	//ͬʧ
	else return 0; 			//ͬɹ 
}
//RTCдSRAM
//BKPx:Ĵ,Χ:0~19
//data:Ҫд,32λ
void RTC_Write_BKR(u32 BKRx,u32 data)
{
	u32 temp=0; 
	temp=RTC_BASE+0x50+BKRx*4;   
	(*(u32*)temp)=data; 
}
//RTCȡSRAM
//BKPx:Ĵ,Χ:0~19
//ֵ:ȡ
u32 RTC_Read_BKR(u32 BKRx)
{
	u32 temp=0; 
	temp=RTC_BASE+0x50+BKRx*4;  
	return (*(u32*)temp);		//ضȡֵ
}

//ʮתΪBCD
//val:Ҫתʮ
//ֵ:BCD
u8 RTC_DEC2BCD(u8 val)
{
	u8 bcdhigh = 0; 
	while(val>=10)
	{
		bcdhigh++;
		val-=10;
	} 
	return ((u8)(bcdhigh<<4)|val);
}
//BCDתΪʮ
//val:ҪתBCD
//ֵ:ʮ
u8 RTC_BCD2DEC(u8 val)
{
	u8 temp=0;
	temp=(val>>4)*10;
	return (temp+(val&0X0F));
}
//RTCʱ
//hour,min,sec:Сʱ,,
//ampm:AM/PM,0=AM/24H,1=PM.
//ֵ:0,ɹ
//       1,ʼģʽʧ 
u8 RTC_Set_Time(u8 hour,u8 min,u8 sec,u8 ampm)
{
	u32 temp=0;
	//رRTCĴд
	RTC->WPR=0xCA;
	RTC->WPR=0x53; 
	if(RTC_Init_Mode())return 1;//RTCʼģʽʧ
	temp=(((u32)ampm&0X01)<<22)|((u32)RTC_DEC2BCD(hour)<<16)|((u32)RTC_DEC2BCD(min)<<8)|(RTC_DEC2BCD(sec));
	RTC->TR=temp;
	RTC->ISR&=~(1<<7);			//˳RTCʼģʽ 
	return 0; 
}
//RTC
//year,month,date:(0~99),(1~12),(0~31)
//week:(1~7,0,Ƿ!)
//ֵ:0,ɹ
//       1,ʼģʽʧ 
u8 RTC_Set_Date(u8 year,u8 month,u8 date,u8 week)
{
	u32 temp=0;
 	//رRTCĴд
	RTC->WPR=0xCA;
	RTC->WPR=0x53; 
	if(RTC_Init_Mode())return 1;//RTCʼģʽʧ
	temp=(((u32)week&0X07)<<13)|((u32)RTC_DEC2BCD(year)<<16)|((u32)RTC_DEC2BCD(month)<<8)|(RTC_DEC2BCD(date)); 
	RTC->DR=temp;
	RTC->ISR&=~(1<<7);			//˳RTCʼģʽ 
	return 0; 
}
//ȡRTCʱ
//*hour,*min,*sec:Сʱ,, 
//*ampm:AM/PM,0=AM/24H,1=PM.
void RTC_Get_Time(u8 *hour,u8 *min,u8 *sec,u8 *ampm)
{
	u32 temp=0;
 	while(RTC_Wait_Synchro());	//ȴͬ  	 
	temp=RTC->TR;
	*hour=RTC_BCD2DEC((temp>>16)&0X3F);
	*min=RTC_BCD2DEC((temp>>8)&0X7F);
	*sec=RTC_BCD2DEC(temp&0X7F);
	*ampm=temp>>22; 
}
//ȡRTC
//*year,*mon,*date:,,
//*week:
void RTC_Get_Date(u8 *year,u8 *month,u8 *date,u8 *week)
{
	u32 temp=0;
 	while(RTC_Wait_Synchro());	//ȴͬ  	 
	temp=RTC->DR;
	*year=RTC_BCD2DEC((temp>>16)&0XFF);
	*month=RTC_BCD2DEC((temp>>8)&0X1F);
	*date=RTC_BCD2DEC(temp&0X3F);
	*week=(temp>>13)&0X07; 
}
//RTCʼ
//ֵ:0,ʼɹ;
//       1,LSEʧ;
//       2,ʼģʽʧ;
u8 RTC_Init(void)
{
	u16 retry=0X1FFF; 
	RCC->APB1ENR|=1<<28;			//ʹܵԴӿʱ
	PWR->CR|=1<<8;					//ʹ(RTC+SRAM)
	if(RTC_Read_BKR(0)!=0X5050)		//Ƿһ?
	{
		RCC->BDCR|=1<<0;			//LSE   
		while(retry&&((RCC->BDCR&0X02)==0))//ȴLSE׼
		{
			retry--;
			delay_ms(5);
		}
		if(retry==0)return 1;		//LSE ʧ. 
		RCC->BDCR|=1<<8;			//ѡLSE,ΪRTCʱ
		RCC->BDCR|=1<<15;			//ʹRTCʱ
 		//رRTCĴд
		RTC->WPR=0xCA;
		RTC->WPR=0x53; 
		if(RTC_Init_Mode())return 2;//RTCʼģʽ
		RTC->PRER=0XFF;				//RTCͬƵϵ(0~7FFF),ͬƵ,첽Ƶ,Frtc=Fclks/((Sprec+1)*(Asprec+1))
		RTC->PRER|=0X7F<<16;		//RTC첽Ƶϵ(1~0X7F)
		RTC->CR&=~(1<<6);			//RTCΪ,24Сʱʽ
		RTC->ISR&=~(1<<7);			//˳RTCʼģʽ
		RTC->WPR=0xFF;				//ʹRTCĴд  
		RTC_Set_Time(23,59,56,0);	//ʱ
		RTC_Set_Date(14,5,5,6);		//
		//RTC_Set_AlarmA(7,0,0,10);	//ʱ
		RTC_Write_BKR(0,0X5050);	//Ѿʼ
	} 
	//RTC_Set_WakeUp(4,0);			//WAKE UPж,1жһ 
	return 0;
}
//ʱ(,24Сʱ)
//week:ڼ(1~7)
//hour,min,sec:Сʱ,,
void RTC_Set_AlarmA(u8 week,u8 hour,u8 min,u8 sec)
{ 
	//رRTCĴд
	RTC->WPR=0xCA; 
	RTC->WPR=0x53;
	RTC->CR&=~(1<<8);	//رA
	while((RTC->ISR&0X01)==0);//ȴA޸ 
	RTC->ALRMAR=0;		//ԭ
	RTC->ALRMAR|=1<<30;	// 
	RTC->ALRMAR|=0<<22;	//24Сʱ
	RTC->ALRMAR|=(u32)RTC_DEC2BCD(week)<<24;//
	RTC->ALRMAR|=(u32)RTC_DEC2BCD(hour)<<16;//Сʱ
	RTC->ALRMAR|=(u32)RTC_DEC2BCD(min)<<8;	//
	RTC->ALRMAR|=(u32)RTC_DEC2BCD(sec);		//  
	RTC->ALRMASSR=0;						//ʹSUB SEC
	RTC->CR|=1<<12;		//Aж
	RTC->CR|=1<<8;		//A 
	RTC->WPR=0XFF;		//ֹ޸RTCĴ 
	
	RTC->ISR&=~(1<<8);	//RTCAı־
	EXTI->PR=1<<17;  	//LINE17ϵжϱ־λ  
	EXTI->IMR|=1<<17;	//line17ϵж 
	EXTI->RTSR|=1<<17;	//line17¼ش 
	MY_NVIC_Init(2,2,RTC_Alarm_IRQn,2); //ռ2ȼ22 
}
//ԻѶʱ
//wksel:000,RTC/16;001,RTC/8;010,RTC/4;011,RTC/2;
//      10x,ck_spre,1Hz;11x,1Hz,cntֵ2^16(cnt+2^16)
//ע:RTCRTCʱƵ,RTCCLK!
//cnt:Զװֵ.0,ж.
void RTC_Set_WakeUp(u8 wksel,u16 cnt)
{ 
	//رRTCĴд
	RTC->WPR=0xCA; 
	RTC->WPR=0x53;
	RTC->CR&=~(1<<10);			//رWAKE UP
	while((RTC->ISR&0X04)==0);	//ȴWAKE UP޸
	RTC->CR&=~(7<<0);			//ԭ
	RTC->CR|=wksel&0X07;		//µֵ
	RTC->WUTR=cnt;				//WAKE UPԶװؼĴֵ
	RTC->ISR&=~(1<<10);			//RTC WAKE UPı־
	RTC->CR|=1<<14;				//WAKE UP ʱж
	RTC->CR|=1<<10;				//WAKE UP ʱ
	RTC->WPR=0XFF;				//ֹ޸RTCĴ 
	EXTI->PR=1<<22;  			//LINE22ϵжϱ־λ  
	EXTI->IMR|=1<<22;			//line22ϵж 
	EXTI->RTSR|=1<<22;			//line22¼ش 
	MY_NVIC_Init(2,2,RTC_WKUP_IRQn,2); //ռ2ȼ22 
}

//RTCжϷ
void RTC_Alarm_IRQHandler(void)
{    
	if(RTC->ISR&(1<<8))//ALARM Aж?
	{
		RTC->ISR&=~(1<<8);	//жϱ־
		printf("ALARM A!\r\n");
	}   
	EXTI->PR|=1<<17;	//ж17жϱ־ 											 
}

//RTC WAKE UPжϷ
void RTC_WKUP_IRQHandler(void)
{    
	if(RTC->ISR&(1<<10))//WK_UPж?
	{ 
		RTC->ISR&=~(1<<10);	//жϱ־
	}   
	EXTI->PR|=1<<22;	//ж22жϱ־ 								
}
u8 const table_week[12]={0,3,3,6,1,4,6,2,5,0,3,5}; //ݱ	  
//ڼ
//:빫ڵõ(ֻ1901-2099)
//year,month,day 
//ֵں(1~7,1~)																						 
u8 RTC_Get_Week(u16 year,u8 month,u8 day)
{	
	u16 temp2;
	u8 yearH,yearL;
	yearH=year/100;	yearL=year%100; 
	// Ϊ21,100  
	if (yearH>19)yearL+=100;
	// ֻ1900֮  
	temp2=yearL+yearL/4;
	temp2=temp2%7; 
	temp2=temp2+day+table_week[month-1];
	if (yearL%4==0&&month<3)temp2--;
	temp2%=7;
	if(temp2==0)temp2=7;
	return temp2;
}	













