/*
ע⣡VDDʹSTM32F429-DISCOϵ3V(ʵ2.9V)磡Ҫ3.3V
*/

#include "touch.h"
#include "delay.h"
#include "usart.h"
#include "exti.h"
#include "GUI.h"


unsigned char T_flag;


struct _ts_event ts_event;
/****************************/
/*           ģI2Cӿ 
			T_SDA=PC2
			T_SCL=PC3
			T_RST=PA4
			T_INT=PE4		
I2C Interface Timing Characteristics:
			SCL frequency  																		10 ~ 400  KHz
			Bus free time between a STOP and START condition  4.7 us
			Hold time (repeated) START condition  						4.0 us
			Data setup time  																	250 ns
			Setup time for a repeated START condition  				4.7 us
			Setup Time for STOP condition  										4.0 us
*/
void Set_T_SDA_OUT(void)//T_SDAΪ PC2
{
	GPIOC->MODER|=1<<4;//PC2 ͨ
	GPIOC->OTYPER&=~(1<<2);//
	GPIOC->OSPEEDR|=3<<4;//100MHZ
	GPIOC->PUPDR|=1<<4;//
	
	T_SDA1;
}

void Set_T_SDA_IN(void)//T_SDAΪ PC2
{
	GPIOC->MODER&=~(3<<4);//PC2 
	GPIOC->PUPDR|=1<<4;//
	T_SDA1;
}

void ACK_To_FT5206(void)//->ӻACK
{	
	T_SCL0;
	T_SDA0;
	delay_us(5);
	T_SCL1;
	delay_us(5);
	T_SCL0;
	T_SDA1;//
}

unsigned char ACK_From_FT5206(void)//ӻ->ACK 
{	
	u16 num=200;
	unsigned int temp=1;
	T_flag=1;
	T_SDA1;	
	Set_T_SDA_IN();	
	EXTI->IMR|=1<<0;//ʹж	
	T_SCL1;
	delay_us(5);
	while(T_flag&&num)//
		{
			temp=Read_SDA;
			//if(!num)return 0;
			//else 
				num--;
		}//ȴж
	EXTI->IMR&=~(1<<0);//ж
	T_SCL0;	
	Set_T_SDA_OUT();
	if(temp)return 1;
	else return 0;//success
}

void FT5206_I2C_Start(void)
{
	T_SDA1;
	T_SCL1;
	delay_us(5);
	T_SDA0;
	delay_us(5);
	T_SCL0;
}

void FT5206_I2C_Stop(void)
{
	T_SDA0;
	T_SCL0;
	delay_us(5);
	T_SCL1;
	T_SDA1;
	delay_us(5);//Bus free time between a STOP and START condition 4.7us
}

void FT5206_WriteByte(unsigned char a)
{
	u8 i;
	T_SCL0;	
	for(i=0;i<8;i++)
	{			
		if(a&0x80){T_SDA1;}//T_SDA=a&0x80
		else{T_SDA0;}	
		a<<=1;			
		T_SCL1;		
		delay_us(5);
		T_SCL0;
		delay_us(5);
	}
}

unsigned char FT5206_ReadByte(void)
{
	u8 i;
	unsigned int buf;
	unsigned char temp=0;
	Set_T_SDA_IN();
	for(i=0;i<8;i++)
	{
		T_SCL0;	
		delay_us(5);				
		buf=Read_SDA;
		T_SCL1;
		delay_us(5);
		if(buf){temp|=(1<<(7-i));}//temp=T_SDA
	}
	Set_T_SDA_OUT();
	return temp;
}

void FT5206_Init(void)
{
/*			T_SDA=PC2
				T_SCL=PC3
				T_RST=PA4
				T_INT=PE4 (жϳʼ)
*/
	//PG10  IICȡʱSDAҪΪ ǰԭΪ
		RCC->AHB1ENR|=((1<<0)|(1<<2));//PA PC ʱʹ
	
		GPIOC->MODER|=((1<<4)|(1<<6));//PC2 3 ͨ
		GPIOC->OTYPER&=~((1<<2)|(1<<3));//
		GPIOC->OSPEEDR|=((3<<4)|(3<<6));//100MHZ
		GPIOC->PUPDR|=((1<<4)|(1<<6));//
		
		GPIOA->MODER|=1<<8;//PA4 ͨ RST
		GPIOA->OTYPER&=~(1<<4);//
		GPIOA->OSPEEDR|=3<<8;//100MHZ
		GPIOA->PUPDR|=1<<8;//	
	
		EXTIX_Init();	
	
		T_RST0;
		delay_ms(10);
		T_RST1;
		delay_ms(80);//WAKEUP
}

void T_Scan(void)
{
		u8 temp=1;
		T_flag=1;
		ts_event.points=0;
		ts_event.gestureID=0;
		ts_event.x1=0;
		ts_event.y1=0;
		ts_event.x2=0;
		ts_event.y2=0;	
		FT5206_I2C_Start();//read
		FT5206_WriteByte(0x71);
		do{temp=ACK_From_FT5206();
		}while(temp);
		ts_event.dummy=FT5206_ReadByte();//NULL
		ACK_To_FT5206();
		ts_event.gestureID=FT5206_ReadByte();//
		ACK_To_FT5206();
		ts_event.points=FT5206_ReadByte();//
		ACK_To_FT5206();		
		ts_event.x1=FT5206_ReadByte();//X1 H
		ts_event.x1<<=8;
		ACK_To_FT5206();
		ts_event.x1|=FT5206_ReadByte();//X1 L
		ACK_To_FT5206();	
		ts_event.y1=FT5206_ReadByte();//Y1 H
		ts_event.y1<<=8;
		ACK_To_FT5206();
		ts_event.y1|=FT5206_ReadByte();//Y1 L
		/*ACK_To_FT5206();
		ts_event.dummy=FT5206_ReadByte();//NULL
		ACK_To_FT5206();
		ts_event.dummy=FT5206_ReadByte();//NULL
		ACK_To_FT5206();
		ts_event.x2=FT5206_ReadByte();//X2 H
		ts_event.x2<<=8;
		ACK_To_FT5206();
		ts_event.x2|=FT5206_ReadByte();//X2 L
		ACK_To_FT5206();
		ts_event.y2=FT5206_ReadByte();//Y2 H
		ts_event.y2<<=8;
		ACK_To_FT5206();
		ts_event.y2|=FT5206_ReadByte();//Y2 L*/
		//ACK_To_FT5206();
		
		FT5206_I2C_Stop();
					
		if((ts_event.x1<=32768)||(ts_event.x1>=32768+800))ts_event.x1=0;
		else ts_event.x1-=32768;
		if(ts_event.y1>=4100)ts_event.y1-=4100;//2
		if(ts_event.x1==0)ts_event.y1=0;//yЧ
		
		/*if((ts_event.x2<=32768)||(ts_event.x2>=32768+800))ts_event.x2=0;
		else ts_event.x2-=32768;
		if(ts_event.y2>=61440)ts_event.y2-=61440;
		else ts_event.y2-=4100;
		if(ts_event.x2==0)ts_event.y2=0;//yЧ
		*/
		
		GUI_TOUCH_StoreState(ts_event.x1,ts_event.y1);
}



