#ifndef __TOUCH_H
#define __TOUCH_H
#include "stm32f4xx_conf.h"

struct _ts_event
{
    u16    x1;
    u16    y1;
    u16    x2;
    u16    y2;
    u16    x3;
    u16    y3;
    u16    x4;
    u16    y4;
    u16    x5;
    u16    y5;
	  u8    points;//
    u8    gestureID;//
	  u8    dummy;//ն
};
extern struct _ts_event ts_event; 

/****************************/
/*    ģI2Cӿ 
			T_SDA=PC2
			T_SCL=PC3
			T_RST=PA4
			T_INT=PE4		
*/
#define T_SDA0 GPIO_ResetBits(GPIOC,GPIO_Pin_2)
#define T_SDA1 GPIO_SetBits(GPIOC,GPIO_Pin_2)
#define T_SCL0 GPIO_ResetBits(GPIOC,GPIO_Pin_3)
#define T_SCL1 GPIO_SetBits(GPIOC,GPIO_Pin_3)
#define T_RST0 GPIO_ResetBits(GPIOA,GPIO_Pin_4)
#define T_RST1 GPIO_SetBits(GPIOA,GPIO_Pin_4)

#define Read_SDA GPIOC->IDR&=1<<2

void Set_T_SDA_OUT(void);
void Set_T_SDA_IN(void);
void ACK_To_FT5206(void);
unsigned char ACK_From_FT5206(void);
void FT5206_I2C_Start(void);
void FT5206_I2C_Stop(void);
void FT5206_WriteByte(unsigned char a);
unsigned char FT5206_ReadByte(void);
void FT5206_Init(void);
void T_Scan(void);

#endif 

